#include "Simulator.h"
#include "OrGate.h"
#include "Inverter.h"
#include "Wire.h"
#include "Source.h"
#include "Meter.h"
int main(int argc, char * argv[]) {
    Simulator sim;
    OrGate or0(1.0f, &sim);
    OrGate or1(2.0f, &sim);
    Inverter not0(0.5f, &sim);
    Inverter not1(0.5f, &sim);    
    Wire w0;
    Wire w1;
    Wire w2;
    Wire w3;
    Wire w4;
    Wire w5;
  
    Source r(argv[1], &sim);
    Source s(argv[2], &sim);
    Meter meter(argv[3]);

    r.connectOutput(&w0);
    or0.connectInput(&w0);
    or0.connectOutput(&w1);
    or0.connectInput(&w5);

    not0.connectInput(&w1);
    not0.connectOutput(&w2);
    
    s.connectOutput(&w3);
    or1.connectInput(&w2);
    or1.connectInput(&w3);
    or1.connectOutput(&w4);
    
    not1.connectInput(&w4);
    not1.connectOutput(&w5);
    
    meter.connectInput(&w0);
    meter.connectInput(&w3);
    meter.connectInput(&w2);
    meter.connectInput(&w5);
    meter.connectInput(&w1);
    meter.connectInput(&w4);
    
    sim.addMeter(&meter);
    sim.simulate();
    
}