#include "Gate.h"
#include <sstream>
Gate::Gate (float d, int nextId, Simulator * ps): id(nextId) {
    p_simulator=ps;
    delay = d;
    futureOutput=output = true;
}

  // UpdateListener class
void Gate::propagateOutputValue() {
  for (int i=0; i<drains.size();i++) // Inform to all input connected to me
    drains[i]->inputValueChanged();
}
  // end UpdateListener 

  // InSignal class
void Gate::inputValueChanged() {
  bool newValue= computeOutput();
  if (newValue!=futureOutput){
     ChangeEvent * e = new ChangeEvent(this, newValue, p_simulator->getTime()+delay);
     p_simulator->add(e);
     futureOutput=newValue;
  }
}
  // end InSignal
  
  // OutSignal class
void Gate::connectOutput(InSignal* p_drain) {
  drains.push_back(p_drain); 
  p_drain->addSource(this);
}

string Gate::getDescription () const {
  stringstream ss;
  string s;
  ss<<getSimpleName()<<"_#"<<id;
  getline(ss,s);
  return s;
}
  // end OutSignal