#include "Simulator.h"

bool CompareEvent::operator() (const ChangeEvent* pea, const ChangeEvent* peb) const {
    return !(pea->time < peb->time);
}

Simulator::Simulator(){
  currentTime = 0;
}

void Simulator::add (ChangeEvent * e){
     pq.push(e);
   }
void Simulator::addMeter(Meter* p_meter) {
  meters.push_back(p_meter);
}
void Simulator::writeHeader(){
  for (int i=0; i<meters.size(); i++)
    meters[i]->writeHeader();
    
}
void Simulator::log(float time){
  for (int i=0; i<meters.size(); i++)
    meters[i]->log(time);
}
void Simulator::simulate() {
  vector <ChangeEvent*> simultEvent; // Vector of simultaneous events
  writeHeader();
  while(!pq.empty()) {
     currentTime = pq.top()->getTime();
     log(currentTime);  // log state before the change
     // get all simultaneous events
     while(true) {
        simultEvent.push_back(pq.top()); pq.pop();
        if (pq.empty()) break;  // done when prioriry queque is empty
        if (pq.top()->getTime()!=currentTime)  //done when event's time changes
           break;
      }
     // update output for each element realy to change
     for (int i=0; i<simultEvent.size(); i++) {
        simultEvent[i]->performUpdate();
     }
     // remove element and propagate its output update to each drain
     while (!simultEvent.empty()){
       ChangeEvent * event=simultEvent.back();
       event->propagateUpdate();
       simultEvent.pop_back();
       delete event;
     }
     log(currentTime);   // log state after the changes      
  }
 
}
float Simulator::getTime() const {
  return currentTime;
}