#include <cstddef>
#include "Wire.h"

Wire::Wire() {
  source=NULL;
}
  // InSignal implementations
void Wire::inputValueChanged() {
  for (int i=0; i< drains.size(); i++)
     drains[i]->inputValueChanged(); 
}
void Wire::connectInput(OutSignal* p_output) {
  source = p_output;
  p_output->addDrain(this);
}
  // InSignal implementations end
  
  // OutSignal implementations
bool Wire::getValue() const {
  return source->getValue();
}
void Wire::connectOutput(InSignal* p_drain){
  drains.push_back(p_drain);
  p_drain->addSource(this);
}
void Wire::addDrain(InSignal * p_drain){
  drains.push_back(p_drain);
}
string Wire::getDescription() const {
  return source->getDescription();
}
  // OutSignal implementations end