#ifndef WIRE
#define WIRE
#include <vector>
#include <string>
#include "InSignal.h"
#include "OutSignal.h"
using namespace std;

class Wire:public InSignal, public OutSignal {
private:
  OutSignal* source;
  vector <InSignal*> drains;
public:
  Wire();
  virtual void inputValueChanged();// InSignal
  virtual void connectInput(OutSignal* p_output); // InSignal
  virtual void addSource(OutSignal* p_output){
    source = p_output;
  }
  virtual bool getValue() const;  // OutSignal
  virtual void connectOutput(InSignal* p_drain); // OutSignal
  virtual void addDrain(InSignal* p_drain); // OutSignal
  virtual string getDescription()const;   // OutSignal
};
#endif